import { Settings } from '../base/Util';
import { Client } from '@elastic/elasticsearch';
import type { ClientOptions } from '@elastic/elasticsearch';
export { UType } from '../base/Util';
export { Static } from '@sinclair/typebox';
export { View, FlatView } from './basic/View';
export { Table } from './basic/Table';
export type { WhereParam, WhereCondition, WhereItem, QuerySchema, MagicSuffix, } from '../base/types';
export type ESSettings = Omit<Settings, 'provider'> & {
    provider: ClientOptions | (() => Client);
};
/**
 * Setup Elastic Search Connection with config
*/
export declare const setup: (settings: ESSettings) => Promise<Client>;
