"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = exports.Table = exports.FlatView = exports.View = exports.UType = void 0;
const lodash_1 = __importDefault(require("lodash"));
const Util_1 = require("../base/Util");
const elasticsearch_1 = require("@elastic/elasticsearch");
var Util_2 = require("../base/Util");
Object.defineProperty(exports, "UType", { enumerable: true, get: function () { return Util_2.UType; } });
var View_1 = require("./basic/View");
Object.defineProperty(exports, "View", { enumerable: true, get: function () { return View_1.View; } });
Object.defineProperty(exports, "FlatView", { enumerable: true, get: function () { return View_1.FlatView; } });
var Table_1 = require("./basic/Table");
Object.defineProperty(exports, "Table", { enumerable: true, get: function () { return Table_1.Table; } });
/**
 * Setup Elastic Search Connection with config
*/
const setup = (settings) => __awaiter(void 0, void 0, void 0, function* () {
    let client;
    if (lodash_1.default.isFunction(settings.provider)) {
        client = settings.provider();
    }
    else {
        client = new elasticsearch_1.Client(settings.provider);
    }
    (0, Util_1.setup)(Object.assign(Object.assign({}, settings), { provider: ['es', () => client] }));
    return client;
});
exports.setup = setup;
