import { ClientBase, Pool, PoolConfig } from 'pg';
import { Settings } from '../base/Util';
import { SqlBuilder, SqlExecutor } from '../base/sql';
import { BaseView, TableOptions } from '../base/BaseView';
import { BaseTable } from '../base/BaseTable';
import type { DB_TYPE } from '../base/types';
import type { Static, TObject } from '@sinclair/typebox';
export { UType } from '../base/Util';
export type { WhereParam, WhereCondition, WhereItem, QuerySchema, MagicSuffix, } from '../base/types';
export type { Static } from '@sinclair/typebox';
type Connection = ClientBase | Pool;
export declare class View<T extends TObject> extends BaseView<T, Connection> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<T>;
    /**
     * 1. INIT  _CONFIG.fields_query  AND _CONFIG.fields_get
     * 5. Fix Where Condition (NEED BUILDER?)
    */
    protected init(schema: T, options?: TableOptions): void;
    /**
     * same arguments as pg.query()
     * */
    sql: ClientBase['query'];
}
export declare class Table<T extends TObject> extends BaseTable<T, Connection> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<Static<T>>;
    protected init(schema: T, options?: TableOptions): void;
    /**
     * same arguments as pg.query()
     * */
    sql: ClientBase['query'];
}
export type PGSettings = Omit<Settings, 'provider'> & {
    provider: PoolConfig | (() => ClientBase | Pool);
};
export declare const setup: (settings: PGSettings) => Promise<Pool>;
