"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executor = void 0;
const Util_1 = require("../../base/Util");
const toPromise_1 = require("./toPromise");
const log = (SQL, PARAM) => {
    if (Util_1.ShowSql == null)
        return;
    (0, Util_1.ShowSql)(`${SQL} | ${JSON.stringify(PARAM)}`);
};
exports.executor = {
    add: (db, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        try {
            const result = yield (0, toPromise_1._exec)(db, SQL, PARAM);
            if (result.changes == 1) {
                return result.lastID;
            }
            throw new Error('Insert Error');
        }
        catch (e) {
            throw new Error(e);
        }
    }),
    get: (db, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        return yield (0, toPromise_1._get)(db, SQL, PARAM);
    }),
    query: (db, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        return yield (0, toPromise_1._query)(db, SQL, PARAM);
    }),
    execute: (db, SQL, PARAM = []) => __awaiter(void 0, void 0, void 0, function* () {
        log(SQL, PARAM);
        const result = yield (0, toPromise_1._exec)(db, SQL, PARAM);
        return result.changes;
    }),
};
