import { BaseView } from '../base/BaseView';
import { BaseTable } from '../base/BaseTable';
import { Settings } from '../base/Util';
import type { Static, TObject } from '@sinclair/typebox';
import type { DB_TYPE } from '../base/types';
import type { SqlBuilder, SqlExecutor } from '../base/sql';
import type { TableOptions } from '../base/BaseView';
import type { Database } from 'sqlite3';
export { UType } from '../base/Util';
export type { WhereParam, WhereCondition, WhereItem, QuerySchema, MagicSuffix, } from '../base/types';
export type { Static } from '@sinclair/typebox';
export declare class View<T extends TObject> extends BaseView<T, Database> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<T>;
    protected init(schema: T, options?: TableOptions): void;
}
export declare class Table<T extends TObject> extends BaseTable<T, Database> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<Static<T>>;
    protected init(schema: T, options?: TableOptions): void;
    add(object: any): Promise<Static<T>>;
    /**
     * same arguments as mysql.query()
     * */
    exec(sql: any, ...args: any[]): Promise<T[]>;
}
export type SqliteSettings = Omit<Settings, 'provider'> & {
    provider: string | (() => Database);
};
export declare const setup: (settings: SqliteSettings) => Promise<Database>;
