import { BaseView } from '../base/BaseView';
import { BaseTable } from '../base/BaseTable';
import type { Static, TObject } from '@sinclair/typebox';
import type { DB_TYPE } from '../base/types';
import type { SqlBuilder, SqlExecutor } from '../base/sql';
import type { TableOptions } from '../base/BaseView';
import type { Database } from 'sql.js';
export declare class View<T extends TObject> extends BaseView<T, Database> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<T>;
    protected init(schema: T, options?: TableOptions): void;
    /**
     * same arguments as sqljs.query()
     * */
    sqlQuery(sql: any, ...args: any[]): Promise<T[]>;
    sqlRun(sql: any, ...args: any[]): Promise<number>;
}
export declare class Table<T extends TObject> extends BaseTable<T, Database> {
    protected _DB_TYPE: DB_TYPE;
    protected _BUILDER: SqlBuilder;
    protected _EXECUTOR: SqlExecutor<Static<T>>;
    protected init(schema: T, options?: TableOptions): void;
    add(object: any): Promise<Static<T>>;
}
