"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = exports.Table = exports.View = exports.UType = void 0;
const sql_wasm_1 = __importDefault(require("sql.js/dist/sql-wasm"));
const fs_1 = require("fs");
const Util_1 = require("../base/Util");
const save_1 = require("./basic/save");
var Util_2 = require("../base/Util");
Object.defineProperty(exports, "UType", { enumerable: true, get: function () { return Util_2.UType; } });
var core_1 = require("./core");
Object.defineProperty(exports, "View", { enumerable: true, get: function () { return core_1.View; } });
Object.defineProperty(exports, "Table", { enumerable: true, get: function () { return core_1.Table; } });
const fs_2 = require("fs");
const setup = (settings) => __awaiter(void 0, void 0, void 0, function* () {
    // let db: Database;
    const dbPath = settings.provider.db;
    const save = (data) => __awaiter(void 0, void 0, void 0, function* () {
        (0, fs_2.writeFileSync)(dbPath, data);
        return true;
    });
    (0, save_1.setSaveFunction)(save);
    const SQL = yield (0, sql_wasm_1.default)({ wasmBinary: (0, fs_1.readFileSync)(settings.provider.wasm) });
    ;
    (0, Util_1.setup)(Object.assign(Object.assign({}, settings), { provider: ['sqlite', () => {
                const buffer = (0, fs_1.readFileSync)(settings.provider.db);
                return new SQL.Database(buffer);
            }] }));
    const buffer = (0, fs_1.readFileSync)(settings.provider.db);
    return new SQL.Database(buffer);
});
exports.setup = setup;
