import { Settings } from '../base/Util';
export { View, Table } from './core';
import type { Database } from 'sql.js';
export { UType } from '../base/Util';
export type { WhereParam, WhereCondition, WhereItem, QuerySchema, MagicSuffix, } from '../base/types';
export type { Static } from '@sinclair/typebox';
import type { SaveFunction } from './basic/save';
export type SqliteSettings = Omit<Settings, 'provider'> & {
    provider: {
        wasm: string;
        db: string;
        onSave?: SaveFunction;
    };
};
export declare const setup: (settings: SqliteSettings) => Promise<Database>;
