"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = exports.UType = exports.Table = exports.View = void 0;
const lodash_1 = __importDefault(require("lodash"));
const sql_js_1 = __importDefault(require("sql.js"));
const Util_1 = require("../base/Util");
var core_1 = require("./core");
Object.defineProperty(exports, "View", { enumerable: true, get: function () { return core_1.View; } });
Object.defineProperty(exports, "Table", { enumerable: true, get: function () { return core_1.Table; } });
var Util_2 = require("../base/Util");
Object.defineProperty(exports, "UType", { enumerable: true, get: function () { return Util_2.UType; } });
const save_1 = require("./basic/save");
const setup = (settings) => __awaiter(void 0, void 0, void 0, function* () {
    let db;
    const SQL = yield (0, sql_js_1.default)({ locateFile: file => settings.provider.wasm });
    const resp = yield fetch("/path/to/database.sqlite");
    const buf = yield resp.arrayBuffer();
    db = new SQL.Database(new Uint8Array(buf));
    if (lodash_1.default.isFunction(settings.provider.onSave)) {
        (0, save_1.setSaveFunction)(settings.provider.onSave);
    }
    (0, Util_1.setup)(Object.assign(Object.assign({}, settings), { provider: ['sqlite', () => db] }));
    return db;
});
exports.setup = setup;
